//=============================================================================
// Portal Gun
//=============================================================================
class MSPortalGun extends DeusExWeapon;

#exec TEXTURE IMPORT NAME="YellowPortal" FILE="C:\DeusEx\MSPortalGun\Textures\YellowPortal.pcx" GROUP=Skins FLAGS=2
#exec TEXTURE IMPORT NAME="BluePortal" FILE="C:\DeusEx\MSPortalGun\Textures\BluePortal.pcx" GROUP=Skins FLAGS=2

var Portal Bomb;
var BlackHole BH;
var YellowPortal yportal;
var BluePortal bportal;
var YellowPortal2 yportal2;
var BluePortal2 bportal2;
var YellowPortal3 yportal3;
var BluePortal3 bportal3;
var YellowPortal4 yportal4;
var BluePortal4 bportal4;
var OmniYellowPortal yportal5;
var OmniBluePortal bportal5;
var PersonalYellowPortal pyportal;
var PersonalBluePortal pbportal;
var travel byte ColorMode1;
var travel byte ColorMode2;
var travel byte ColorMode3;
var travel byte ColorMode4;
var travel byte ColorMode5;
var travel byte PortalMode;
var localized String msgPortalFailure;
var localized String msgHasPortals;
var Bool yportal1exists;
var Bool bportal1exists;
var Bool yportal2exists;
var Bool bportal2exists;
var Bool yportal3exists;
var Bool bportal3exists;
var Bool yportal4exists;
var Bool bportal4exists;
var Bool yportal5exists;
var Bool bportal5exists;
//var Bool bCarryingThing;

state NormalFire
{
Begin:
	if ((ClipCount >= ReloadCount) && (ReloadCount != 0))
	{
		if (!bAutomatic)
		{
			bFiring = False;
			FinishAnim();
		}

		if (Owner != None)
		{
			if (Owner.IsA('DeusExPlayer'))
			{
				bFiring = False;


				// should we autoreload?
				if (DeusExPlayer(Owner).bAutoReload)
				{
					// auto switch ammo if we're out of ammo and
					// we're not using the primary ammo
					if ((AmmoType.AmmoAmount == 0) && (AmmoName != AmmoNames[0]))
						CycleAmmo();
					ReloadAmmo();
				}
				else
				{
					if (bHasMuzzleFlash)
						EraseMuzzleFlashTexture();
					GotoState('Idle');
				}
			}
			else if (Owner.IsA('ScriptedPawn'))
			{
				bFiring = False;
				ReloadAmmo();
			}
		}
		else
		{
			if (bHasMuzzleFlash)
				EraseMuzzleFlashTexture();
			GotoState('Idle');
		}
	}
	if ( bAutomatic && (( Level.NetMode == NM_DedicatedServer ) || ((Level.NetMode == NM_ListenServer) && Owner.IsA('DeusExPlayer') && !DeusExPlayer(Owner).PlayerIsListenClient())))
		GotoState('Idle');

	Sleep(GetShotTime());
	if (bAutomatic)
	{
		GenerateBullet();	// In multiplayer bullets are generated by the client which will let the server know when
		Goto('Begin');
	}
	bFiring = False;
	FinishAnim();

	ReadyToFire();
Done:
	bFiring = False;
	Finish();
}

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
local YellowPortal yportal;
local BluePortal bportal;
local YellowPortal2 yportal2;
local BluePortal2 bportal2;
local YellowPortal3 yportal3;
local BluePortal3 bportal3;
local YellowPortal4 yportal4;
local BluePortal4 bportal4;
local OmniYellowPortal yportal5;
local OmniBluePortal bportal5;
local DeusExPlayer P;
P = DeusExPlayer(Owner);
if (P != None)    
{ 
 if (PortalMode == 0)
 {
  if (ColorMode1 == 0)
  {
   if ((Other != None) && Other.IsA('Pawn') || Other.IsA('Decoration') || Other.IsA('PortalBlocker'))
   {
		Pawn(Owner).ClientMessage(msgPortalFailure);
		return;
   }
   else
   {
    if (!bportal1exists)
    {
    ColorMode1 = 1;
    bportal = spawn(class'BluePortal',P,,HitLocation);
    bportal1exists = True;
    }
    else if (bportal1exists)
    {
    Pawn(Owner).ClientMessage(msgHasPortals);
    }
   }
  }
  else if (ColorMode1 == 1)
  {
   if ((Other != None) && Other.IsA('Pawn') || Other.IsA('Decoration') || Other.IsA('PortalBlocker'))
   {
		Pawn(Owner).ClientMessage(msgPortalFailure);
		return;
   }
   else
   {
    if (!yportal1exists)
    {
    ColorMode1 = 0;
    yportal = spawn(class'YellowPortal',P,,HitLocation);
    yportal1exists = True;
    }
    else if (yportal1exists)
    {
    Pawn(Owner).ClientMessage(msgHasPortals);
    }
   }
  }
 }
 else if (PortalMode == 1)
 {
  if (ColorMode2 == 0)
  {
   if ((Other != None) && Other.IsA('Pawn') || Other.IsA('Decoration') || Other.IsA('PortalBlocker'))
   {
		Pawn(Owner).ClientMessage(msgPortalFailure);
		return;
   }
   else
   {
    if (!bportal2exists)
    {
    ColorMode2 = 1;
    bportal2 = spawn(class'BluePortal2',P,,HitLocation);
    bportal2exists = True;
    }
    else if (bportal2exists)
    {
    Pawn(Owner).ClientMessage(msgHasPortals);
    }
   }
  }
  else if (ColorMode2 == 1)
  {
   if ((Other != None) && Other.IsA('Pawn') || Other.IsA('Decoration') || Other.IsA('PortalBlocker'))
   {
		Pawn(Owner).ClientMessage(msgPortalFailure);
		return;
   }
   else
   {
    if (!yportal2exists)
    {
    ColorMode2 = 0;
    yportal2 = spawn(class'YellowPortal2',P,,HitLocation);
    yportal2exists = True;
    }
    else if (yportal2exists)
    {
    Pawn(Owner).ClientMessage(msgHasPortals);
    }
   }
  }
 }
 else if (PortalMode == 2)
 {
  if (ColorMode3 == 0)
  {
   if ((Other != None) && Other.IsA('Pawn') || Other.IsA('Decoration') || Other.IsA('PortalBlocker'))
   {
		Pawn(Owner).ClientMessage(msgPortalFailure);
		return;
   }
   else
   {
    if (!bportal3exists)
    {
    ColorMode3 = 1;
    bportal3 = spawn(class'BluePortal3',P,,HitLocation);
    bportal3exists = True;
    }
    else if (bportal3exists)
    {
    Pawn(Owner).ClientMessage(msgHasPortals);
    }
   }
  }
  else if (ColorMode3 == 1)
  {
   if ((Other != None) && Other.IsA('Pawn') || Other.IsA('Decoration') || Other.IsA('PortalBlocker'))
   {
		Pawn(Owner).ClientMessage(msgPortalFailure);
		return;
   }
   else
   {
    if (!yportal3exists)
    {
    ColorMode3 = 0;
    yportal3 = spawn(class'YellowPortal3',P,,HitLocation);
    yportal3exists = True;
    }
    else if (yportal3exists)
    {
    Pawn(Owner).ClientMessage(msgHasPortals);
    }
   }
  }
 }
 else if (PortalMode == 3)
 {
  if (ColorMode4 == 0)
  {
   if ((Other != None) && Other.IsA('Pawn') || Other.IsA('Decoration') || Other.IsA('PortalBlocker'))
   {
		Pawn(Owner).ClientMessage(msgPortalFailure);
		return;
   }
   else
   {
    if (!bportal4exists)
    {
    ColorMode4 = 1;
    bportal4 = spawn(class'BluePortal4',P,,HitLocation);
    bportal4exists = True;
    }
    else if (bportal4exists)
    {
    Pawn(Owner).ClientMessage(msgHasPortals);
    }
   }
  }
  else if (ColorMode4 == 1)
  {
   if ((Other != None) && Other.IsA('Pawn') || Other.IsA('Decoration') || Other.IsA('PortalBlocker'))
   {
		Pawn(Owner).ClientMessage(msgPortalFailure);
		return;
   }
   else
   {
    if (!yportal4exists)
    {
    ColorMode4 = 0;
    yportal4 = spawn(class'YellowPortal4',P,,HitLocation);
    yportal4exists = True;
    }
    else if (yportal4exists)
    {
    Pawn(Owner).ClientMessage(msgHasPortals);
    }
   }
  }
 }
 else if (PortalMode == 4)
 {
    spawn(class'MSPortalGun6.BlackHole',P,,HitLocation);
 }
 else if (PortalMode == 5)
 {
    ForEach AllActors(class'Portal',Bomb)
    {
        if (Bomb != None)
        {
            Bomb.Explode(HitLocation);
        }
    }
    ColorMode1=0;
    ColorMode2=0;
    ColorMode3=0;
    ColorMode4=0;
    ColorMode5=0;
    bportal1exists = False;
    yportal1exists = False;
    bportal2exists = False;
    yportal2exists = False;
    bportal3exists = False;
    yportal3exists = False;
    bportal4exists = False;
    yportal4exists = False;
    bportal5exists = False;
    yportal5exists = False;
 }
 else if (PortalMode == 6)
 {
  if (ColorMode5 == 0)
  {
   if ((Other != None) && Other.IsA('Pawn') || Other.IsA('Decoration') || Other.IsA('PortalBlocker'))
   {
		Pawn(Owner).ClientMessage(msgPortalFailure);
		return;
   }
   else
   {
    if (!bportal5exists)
    {
    ColorMode5 = 1;
    bportal5 = spawn(class'OmniBluePortal',P,,HitLocation);
    bportal5exists = True;
    }
    else if (bportal5exists)
    {
    Pawn(Owner).ClientMessage(msgHasPortals);
    }
   }
  }
  else if (ColorMode5 == 1)
  {
   if ((Other != None) && Other.IsA('Pawn') || Other.IsA('Decoration') || Other.IsA('PortalBlocker'))
   {
		Pawn(Owner).ClientMessage(msgPortalFailure);
		return;
   }
   else
   {
    if (!yportal5exists)
    {
    ColorMode5 = 0;
    yportal5 = spawn(class'OmniYellowPortal',P,,HitLocation);
    yportal5exists = True;
    }
    else if (yportal5exists)
    {
    Pawn(Owner).ClientMessage(msgHasPortals);
    }
   }
  }
 }
}
}
//Other.SetBase(P);

function LaserToggle()
{
local DeusExPlayer P;
P = DeusExPlayer(Owner);
 if (PortalMode == 0)
 {
    ForEach AllActors(class'YellowPortal',yportal)
    {
    if (yportal != None)   
      {
/*      if (yportal.Owner != P)
          {
          return;
          }
      else
          {*/
          yportal.Destroy();
//          }
      }
    }
    ForEach AllActors(class'BluePortal',bportal)
    {    
    if (bportal != None) 
      {
/*      if (bportal.Owner != P)
          {
          return;
          }
      else
          {*/
          bportal.Destroy();
//          }
      }
    }
    bportal1exists = False;
    yportal1exists = False;
    ColorMode1 = 0;
 }
 else if (PortalMode == 1)
 {
    ForEach AllActors(class'YellowPortal2',yportal2)
    {
    if (yportal2 != None) 
      {
//      if (yportal2.Owner != P)
//          {
//          return;
//          }
//      else
//          {
          yportal2.Destroy();
//          }
      }
    }
    ForEach AllActors(class'BluePortal2',bportal2)
    {    
    if (bportal2 != None)  
      {
      if (bportal2.Owner != P)
          {
          return;
          }
      else
          {
          bportal2.Destroy();
          }
      }
    }
    bportal2exists = False;
    yportal2exists = False;
    ColorMode2 = 0;
 }
 else if (PortalMode == 2)
 {
    ForEach AllActors(class'YellowPortal3',yportal3)
    {
    if (yportal3 != None) 
      {
/*      if (yportal3.Owner != P)
          {
          return;
          }
      else
          {*/
          yportal3.Destroy();
//          }
      }
    }
    ForEach AllActors(class'BluePortal3',bportal3)
    {    
    if (bportal3 != None) 
      {
/*      if (bportal3.Owner != P)
          {
          return;
          }
      else
          {*/
          bportal3.Destroy();
//          }
      }
    }
    bportal3exists = False;
    yportal3exists = False;
    ColorMode3 = 0;
 }
 else if (PortalMode == 3)
 {
    ForEach AllActors(class'YellowPortal4',yportal4)
    {
    if (yportal4 != None) 
      {
/*      if (yportal4.Owner != P)
          {
          return;
          }
      else
          {*/
          yportal4.Destroy();
//          }
      }
    }
    ForEach AllActors(class'BluePortal4',bportal4)
    {    
    if (bportal4 != None)  
      {
/*      if (bportal4.Owner != P)
          {
          return;
          }
      else
          {*/
          bportal4.Destroy();
          }
//      }
    }
    bportal4exists = False;
    yportal4exists = False;
    ColorMode4 = 0;
 }
 else if (PortalMode == 4)
 {
    ForEach AllActors(class'BlackHole',BH)
    {
    if (BH != None)
      {
      BH.Destroy();
      }
    }
 }
 else if (PortalMode == 5)
 {
    ForEach AllActors(class'YellowPortal',yportal)
    {
    if (yportal != None) 
      {
      yportal.Destroy();
      }
    yportal1exists = False;
    }
    ForEach AllActors(class'BluePortal',bportal)
    {    
    if (bportal != None) 
      {
      bportal.Destroy();
      }
    bportal1exists = False;
    }
    ForEach AllActors(class'YellowPortal2',yportal2)
    {
    if (yportal2 != None) 
      {
      yportal2.Destroy();
      }
    yportal2exists = False;
    }
    ForEach AllActors(class'BluePortal2',bportal2)
    {    
    if (bportal2 != None) 
      {
      bportal2.Destroy();
      }
    bportal2exists = False;
    }
    ForEach AllActors(class'YellowPortal3',yportal3)
    {
    if (yportal3 != None) 
      {
      yportal3.Destroy();
      }
    yportal3exists = False;
    }
    ForEach AllActors(class'BluePortal3',bportal3)
    {    
    if (bportal3 != None) 
      {
      bportal3.Destroy();
      }
    bportal3exists = False;
    }
    ForEach AllActors(class'YellowPortal4',yportal4)
    {
    if (yportal4 != None) 
      {
      yportal4.Destroy();
      }
    yportal4exists = False;
    }
    ForEach AllActors(class'BluePortal4',bportal4)
    {    
    if (bportal4 != None) 
      {
      bportal4.Destroy();
      }
    bportal4exists = False;
    }
    ForEach AllActors(class'OmniYellowPortal',yportal5)
    {
    if (yportal5 != None) 
      {
      yportal5.Destroy();
      }
    yportal5exists = False;
    }
    ForEach AllActors(class'OmniBluePortal',bportal5)
    {    
    if (bportal5 != None) 
      {
      bportal5.Destroy();
      }
    bportal5exists = False;
    }
    ForEach AllActors(class'PersonalYellowPortal',pyportal)
    {
    if (pyportal != None)  
      {
      pyportal.Destroy();
      }
    }
    ForEach AllActors(class'PersonalBluePortal',pbportal)
    {    
    if (pbportal != None) 
      {
      pbportal.Destroy();
      }
    }
    ForEach AllActors(class'BlackHole',BH)
    {
    if (BH != None)
      {
      BH.Destroy();
      }
    }
    ColorMode1=0;
    ColorMode2=0;
    ColorMode3=0;
    ColorMode4=0;
    ColorMode5=0;
    bportal1exists = False;
    yportal1exists = False;
    bportal2exists = False;
    yportal2exists = False;
    bportal3exists = False;
    yportal3exists = False;
    bportal4exists = False;
    yportal4exists = False;
    bportal5exists = False;
    yportal5exists = False;
   }
 else if (PortalMode == 6)
 {
    ForEach AllActors(class'OmniYellowPortal',yportal5)
    {
    if (yportal5 != None)  
      {
/*      if (yportal5.Owner != P)
          {
          return;
          }
      else
          {*/
          yportal5.Destroy();
//          }
      }
    }
    ForEach AllActors(class'OmniBluePortal',bportal5)
    {    
    if (bportal5 != None)  
      {
/*      if (bportal5.Owner != P)
          {
          return;
          }
      else
          {*/
          bportal5.Destroy();
          }
//      }
    }
    bportal5exists = False;
    yportal5exists = False;
    ColorMode5 = 0;
 }
//    ColorMode=0;
}

Function CycleAmmo()
{
    local DeusExplayer P;
    P=DeusExPlayer(Owner);
        
    if (PortalMode == 0)
    {
        PortalMode = 1;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to move decorations");
        return;
    }
    if (PortalMode == 1)
    {
      if(P.bAdmin)
      {
        PortalMode = 2;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to move pickup items");
        return;
      }
      if(!P.bAdmin)
      {
        PortalMode = 3;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to move projectiles");
        return;
      }
    }
    if (PortalMode == 2)
    {
        PortalMode = 3;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to move projectiles");
        return;
    }
    if (PortalMode == 3)
    {
      if(!P.bAdmin)
      {
        PortalMode = 0;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to move creatures");
        return;
      }
      else if(P.bAdmin)
      {
        PortalMode = 4;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to BLACK HOLE");
        return;
      }
    }
    if (PortalMode == 4)
    {
      if(!P.bAdmin)
      {
        PortalMode = 0;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to move creatures");
        return;
      }
      else if(P.bAdmin)
      {
        PortalMode = 5;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to Erase ALL Portals");
        return;
      }
    }
    if (PortalMode == 5)
    {
      if(!P.bAdmin)
      {
        PortalMode = 0;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to move creatures");
        return;
      }
      else if(P.bAdmin)
      {
        PortalMode = 6;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to Omni-Portal");
        return;
      }
    }
    if (PortalMode == 6)
    {
        PortalMode = 0;
	DeusExPlayer(Owner).Clientmessage("|P4Mode set to move creatures");
        return;
    }
}

defaultproperties
{
     LowAmmoWaterMark=4
     GoverningSkill=Class'DeusEx.SkillWeaponHeavy'
     NoiseLevel=0.000000
     ShotTime=0.500000
     reloadTime=0.000001
     PickupAmmoCount=10
     HitDamage=300
     maxRange=24000
     AccurateRange=14400
     bCanHaveScope=True
     bHasMuzzleFlash=False
     recoilStrength=1.000000
     bUseWhileCrouched=False
     mpHitDamage=40
     mpAccurateRange=14400
     mpMaxRange=14400
     mpReloadCount=0
     AmmoName=Class'DeusEx.AmmoNone'
     ReloadCount=0
     bInstantHit=True
     FireOffset=(X=-46.000000,Y=22.000000,Z=10.000000)
     ProjectileClass=None
     shakemag=0.000000
     FireSound=Sound'DeusExSounds.Weapons.LAWFire'
     SelectSound=Sound'DeusExSounds.Weapons.LAWSelect'
     InventoryGroup=255
     ItemArticle="|p1a"
     ItemName="|p1Markistan Corp Portal Gun"
     PlayerViewOffset=(X=18.000000,Y=-18.000000,Z=-7.000000)
     PlayerViewMesh=LodMesh'DeusExItems.LAW'
     PickupViewMesh=LodMesh'DeusExItems.LAWPickup'
     ThirdPersonMesh=LodMesh'DeusExItems.LAW3rd'
     LandSound=Sound'DeusExSounds.Generic.DropLargeWeapon'
     Icon=Texture'DeusExUI.Icons.BeltIconLAW'
     largeIcon=Texture'DeusExUI.Icons.LargeIconLAW'
     largeIconWidth=166
     largeIconHeight=47
     invSlotsX=4
     Description="A mysterious gun that seems remotely familiar..."
     beltDescription="PORTAL"
     Mesh=LodMesh'DeusExItems.LAWPickup'
     CollisionRadius=27.000000
     CollisionHeight=6.600000
     Mass=5.000000
     msgPortalFailure="Invalid Location."
     msgHasPortals="Portals already in use."
     bCanHaveScope=True
     bHasScope=True
     BaseAccuracy=0.000000
     bEmitWeaponDrawn=False
     bWeaponStay=True
     PickupMessage="|p4Use your laser toggle button (|p3]|p4 by default) to erase portals and your change ammo button to change setting. |p1You have obtained"
}
